--- good boy
freeslot(
"SPR_RUSH",
"SPR_TRBL",
"MT_RUSHCOIL",
"MT_RUSHJET",
"MT_RUSHMARINE",
"MT_TREBLE",
"S_RUSH_ENTER1",
"S_RUSH_ENTER2",
"S_RUSH_ENTER3",
"S_RUSH_IDLE1",
"S_RUSH_IDLE2",
"S_RUSH_IDLE_JET",
"S_RUSH_IDLE1_MARINE",
"S_RUSH_IDLE2_MARINE",
"S_RUSH_IDLE3_MARINE",
"S_TREBLE_IDLE1",
"S_TREBLE_IDLE2",
"S_TREBLE_FIRE",
"S_RUSH_SPRING",
"S_RUSH_EXIT1",
"S_RUSH_EXIT2",
"S_RUSH_EXIT3"
)

rawset(_G, "DogTable", {})

DogTable[MT_RUSHCOIL] = {type = "coil"}
DogTable[MT_RUSHJET] = {type = "jet"} 
DogTable[MT_RUSHMARINE] = {type = "marine"} 
DogTable[MT_TREBLE] = {type = "treble"} 

local height_check = function(thing1, thing2)
	if (thing1.z > thing2.z+thing2.height) or (thing2.z > thing1.z+thing1.height)
		return false
	else
		return true
	end
end
local rush_statecheck = function(rush)
	if rush.state == S_RUSH_ENTER1
	or rush.state == S_RUSH_ENTER2
	or rush.state == S_RUSH_ENTER3
	or rush.state == S_RUSH_EXIT1
	or rush.state == S_RUSH_EXIT2
	or rush.state == S_RUSH_EXIT3
		return false
	else
		return true
	end
end

local rush_jetdust = function(rush)
	local thefloor = rush.floorz
	if rush.eflags & MFE_VERTICALFLIP
		thefloor = rush.ceilingz
	end
	for i = 1, 16
		local dust = P_SpawnMobj(rush.x, rush.y, thefloor, MT_SPINDUST)
		dust.scale = $*2
		dust.target = rush
		dust.fuse = TICRATE
		dust.destscale = dust.scale/8
		P_InstaThrust(dust, i*ANGLE_22h, 60*FRACUNIT)
		dust.momz = 0
	end
end

mobjinfo[MT_RUSHCOIL] = {
	spawnstate = S_RUSH_ENTER1,
	deathstate = S_RUSH_EXIT1,
	radius = 12*FRACUNIT,
	height = 32*FRACUNIT, 
	doomednum = 455,
	spawnhealth = 1,
	reactiontime = 8,
	speed = 1,
	dispoffset = 0,
	mass = 100,
	flags = MF_NOCLIPTHING
}

mobjinfo[MT_RUSHJET] = {
	spawnstate = S_RUSH_ENTER1,
	deathstate = S_RUSH_EXIT1,
	radius = 12*FRACUNIT,
	height = 32*FRACUNIT, 
	doomednum = 455,
	spawnhealth = 1,
	reactiontime = 8,
	speed = 1,
	dispoffset = 0,
	mass = 100,
	flags = MF_NOGRAVITY|MF_NOCLIPTHING
}

mobjinfo[MT_RUSHMARINE] = {
	spawnstate = S_RUSH_ENTER1,
	deathstate = S_RUSH_EXIT1,
	radius = 12*FRACUNIT,
	height = 32*FRACUNIT, 
	doomednum = 455,
	spawnhealth = 1,
	reactiontime = 8,
	speed = 1,
	dispoffset = 0,
	mass = 100,
	flags = MF_NOGRAVITY|MF_NOCLIPTHING
	
}

mobjinfo[MT_TREBLE] = {
	spawnstate = S_RUSH_ENTER1,
	deathstate = S_RUSH_EXIT1,
	radius = 12*FRACUNIT,
	height = 32*FRACUNIT, 
	doomednum = 455,
	spawnhealth = 1,
	reactiontime = 8,
	speed = 1,
	dispoffset = 0,
	mass = 100,
	flags = MF_NOCLIPTHING
}

states[S_RUSH_ENTER1] = {
    tics = 4,
	sprite = SPR_RUSH,
	frame = F,
    nextstate = S_RUSH_ENTER2
}

states[S_RUSH_ENTER2] = {
    tics = 4,
	sprite = SPR_RUSH,
	frame = E,
    nextstate = S_RUSH_ENTER3
}

states[S_RUSH_ENTER3] = {
    tics = 4,
	sprite = SPR_RUSH,
	frame = D,
    nextstate = S_RUSH_IDLE1
}

states[S_RUSH_IDLE1] = {
    tics = 3,
	sprite = SPR_RUSH,
	frame = A,
    nextstate = S_RUSH_IDLE2
}

states[S_RUSH_IDLE2] = {
    tics = 3,
	sprite = SPR_RUSH,
	frame = B,
    nextstate = S_RUSH_IDLE1
}

states[S_RUSH_IDLE_JET] = {
    tics = -1,
	sprite = SPR_RUSH,
	frame = I,
    nextstate = S_RUSH_IDLE_JET
}

states[S_RUSH_IDLE1_MARINE] = {
    tics = 3,
	sprite = SPR_RUSH,
	frame = L,
    nextstate = S_RUSH_IDLE2_MARINE
}

states[S_RUSH_IDLE2_MARINE] = {
    tics = 3,
	sprite = SPR_RUSH,
	frame = M,
    nextstate = S_RUSH_IDLE3_MARINE
}

states[S_RUSH_IDLE2_MARINE] = {
    tics = 3,
	sprite = SPR_RUSH,
	frame = L,
    nextstate = S_RUSH_IDLE1_MARINE
}

states[S_TREBLE_IDLE1] = {
    tics = 3,
	sprite = SPR_TRBL,
	frame = B,
    nextstate = S_TREBLE_IDLE2
}

states[S_TREBLE_IDLE2] = {
    tics = 3,
	sprite = SPR_TRBL,
	frame = C,
    nextstate = S_TREBLE_IDLE1
}

states[S_TREBLE_FIRE] = {
    tics = 5,
	sprite = SPR_TRBL,
	frame = I,
    nextstate = S_TREBLE_IDLE1
}

states[S_RUSH_SPRING] = {
    tics = 35,
	sprite = SPR_RUSH,
	frame = C,
    nextstate = S_RUSH_EXIT1
}

states[S_RUSH_EXIT1] = {
    tics = 3,
	sprite = SPR_RUSH,
	frame = E,
    nextstate = S_RUSH_EXIT2
}

states[S_RUSH_EXIT2] = {
    tics = 3,
	sprite = SPR_RUSH,
	frame = D,
    nextstate = S_RUSH_EXIT3
}

states[S_RUSH_EXIT3] = {
    tics = 3,
	sprite = SPR_RUSH,
	frame = F,
    nextstate = S_NULL
}
// general stuff
addHook("MobjSpawn", function(rush)
	if DogTable[rush.type]
		rush.scale = rush.scale*5/2
	end
end)

addHook("MobjThinker", function(rush)
	if DogTable[rush.type]
		if rush.rushtimer == nil
			rush.rushtimer = 0
		end
		if rush.lockon == nil
			rush.lockon = 0
		end
		rush.rushtimer = $ + 1
		if rush.state == S_RUSH_ENTER3
			rush.flags = $|MF_SPECIAL
			rush.flags = $&~MF_NOCLIPTHING
			if rush.type == MT_RUSHJET
				rush.state = S_RUSH_IDLE_JET
			elseif rush.type == MT_RUSHMARINE
				rush.state = S_RUSH_IDLE1_MARINE
			elseif rush.type == MT_TREBLE
				rush.state = S_TREBLE_IDLE1
			end
		end
		if rush.state == S_RUSH_EXIT3
		and rush.target
			rush.target.player.rushout = false
		end
		if rush.type == MT_RUSHJET
		and rush.rushtimer == 28
			rush.rushtimer = 0
			rush_jetdust(rush)
		end
		if rush.type == MT_TREBLE
		and rush.rushtimer == 6
			rush.rushtimer = 0
		end
		if rush.type == MT_TREBLE
			rush.lockon = P_LookForEnemies(rush.target.player, true, true)
			if rush.lockon and rush.lockon.valid and rush.lockon.health
			and rush.type == MT_TREBLE
			and P_CheckSight(rush, rush.target)
			and P_LookForPlayers(rush, 360*FRACUNIT, true, false) 
				P_SpawnLockOn(rush.target.player, rush.lockon, S_LOCKON1)
				local facingangle = R_PointToAngle2(rush.x, rush.y, rush.lockon.x, rush.lockon.y)
				rush.angle = facingangle
				if rush.rushtimer == 5
					rush.state = S_TREBLE_FIRE
					local projectile = P_SpawnMissile(rush, rush.lockon, MT_REDRING)
					projectile.target = rush.target
					projectile.scale = $/3
					projectile.colorzied = true
					projectile.color = SKINCOLOR_PURPLE
				end
			end
		end
		if rush.type == MT_TREBLE
		and rush.rushtimer == 5
		and not rush.lockon
			rush.state = S_TREBLE_FIRE
			local projectile = P_SPMAngle(rush, MT_REDRING, rush.angle)
			projectile.target = rush.target
			projectile.scale = $/3
			projectile.colorzied = true
			projectile.color = SKINCOLOR_PURPLE
		end
		if rush.state == S_TREBLE_FIRE
		and rush.type == MT_TREBLE
		and not rush.lockon
			rush.state = S_TREBLE_IDLE1
		end
		if rush.type == MT_TREBLE
		and rush.target.player.custom1out == false
		and rush_statecheck(rush) == true
			rush.state = S_RUSH_EXIT1
		end
	end
end)
// RUSH COIL STUFF
addHook("TouchSpecial", function(rush, mo)
	if rush and rush.valid
	and mo and mo.valid
		P_SetObjectMomZ(mo,25*FRACUNIT)
		S_StartSound(mo,sfx_spring)
		local facingangle = R_PointToAngle2(rush.x, rush.y, mo.x, mo.y)
		rush.angle = facingangle
		rush.state = S_RUSH_SPRING
		mo.state = S_PLAY_ROLL
		P_ResetPlayer(mo.player)
		mo.player.pflags = $ |PF_JUMPED
		for i = 1, 16 
			local dust = P_SpawnMobjFromMobj(rush,0,0,0,MT_SPINDUST)
			dust.target = rush
			dust.fuse = TICRATE
			dust.scale = mo.scale
			dust.destscale = mo.scale/8
			P_InstaThrust(dust, i*ANGLE_22h, 16*FRACUNIT)
			dust.momz = 0
		end
		return true
	end
end, MT_RUSHCOIL)
addHook("MobjCollide", function(rush, mo)
	if rush and rush.valid
	and mo and mo.valid
	and height_check(rush, mo) == true
		if mo.type == MT_PLAYER
			return
		end
		P_SetObjectMomZ(mo,25*FRACUNIT)
		S_StartSound(mo,sfx_spring)
		local facingangle = R_PointToAngle2(rush.x, rush.y, mo.x, mo.y)
		rush.angle = facingangle
		rush.state = S_RUSH_SPRING
		for i = 1, 16 
			local dust = P_SpawnMobjFromMobj(rush,0,0,0,MT_SPINDUST)
			dust.target = rush
			dust.fuse = TICRATE
			dust.scale = mo.scale
			dust.destscale = mo.scale/8
			P_InstaThrust(dust, i*ANGLE_22h, 16*FRACUNIT)
			dust.momz = 0
		end
	end
end, MT_RUSHCOIL)
// RUSHJET STUFF
addHook("TouchSpecial", function(rush, mo)
	if rush and rush.valid
	and mo and mo.valid
		P_ResetPlayer(mo.player)
		mo.flags = $|MF_NOGRAVITY|MF_FLOAT
		rush.target = mo
		return true
	end
end, MT_RUSHJET)

addHook("MobjThinker", function(rush)
	if rush.target == nil
		return
	end
	local mo = rush.target
	local player = rush.target.player
	if player.cmd.forwardmove < 0
		P_InstaThrust(rush, rush.angle, 5*FRACUNIT)
	elseif player.cmd.forwardmove > 0
		P_InstaThrust(rush, rush.angle, 15*FRACUNIT)
	else
		P_InstaThrust(rush, rush.angle, 10*FRACUNIT)
	end
	if player.cmd.buttons & BT_JUMP
		rush.momz = 3*FRACUNIT
	elseif player.cmd.buttons & BT_SPIN
		rush.momz = -3*FRACUNIT
	else
		rush.momz = 0
	end
	P_MoveOrigin(mo, rush.x, rush.y, rush.z+35*FRACUNIT)
	rush.angle = mo.angle
	mo.state = S_PLAY_STND
	player.rushflytimer = $ - 1
	if player.rushflytimer == 0
	or P_IsObjectOnGround(mo) 
	or (rush.eflags & MFE_UNDERWATER)
	or (mo.eflags & MFE_SPRUNG)
	or P_PlayerInPain(player) and rush.slowdown
	or P_PlayerInPain(player) and rush.speedup
	or P_PlayerInPain(player) and rush.defaultdescent
	or player.exiting == 1
	or (player.playerstate & PST_DEAD)
	or player.cmd.buttons & BT_CUSTOM1
	or not P_TryMove(rush, rush.x+rush.momx, rush.y+rush.momy, true)
		player.weapondelay = TICRATE
		player.rushout = false
		mo.flags = $&~(MF_NOGRAVITY|MF_FLOAT)
		P_DoJump(player, true)
		rush.target = nil
		P_KillMobj(rush, rush, rush)
	end
end, MT_RUSHJET)

// RUSHMARINE STUFF
addHook("TouchSpecial", function(rush, mo)
	if rush and rush.valid
	and mo and mo.valid
		P_ResetPlayer(mo.player)
		mo.flags = $|MF_NOGRAVITY|MF_FLOAT
		rush.target = mo
		return true
	end
end, MT_RUSHMARINE)

addHook("MobjThinker", function(rush)
	if rush.target == nil
		return
	end
	local mo = rush.target
	local player = rush.target.player
	if player.cmd.forwardmove < 0
		local distance = 10
		local fx = P_SpawnMobjFromMobj(rush, P_RandomRange(-distance, distance)*FRACUNIT,  P_RandomRange(-distance, distance)*FRACUNIT, P_RandomRange(-distance, distance)*FRACUNIT, MT_SMALLBUBBLE)
		P_InstaThrust(fx, rush.angle, -10*FRACUNIT)
		fx.momz = P_RandomRange(-10, 10)*FRACUNIT
		P_InstaThrust(rush, rush.angle, -36*FRACUNIT)
	elseif player.cmd.forwardmove > 0
		local distance = 10
		local fx = P_SpawnMobjFromMobj(rush, P_RandomRange(-distance, distance)*FRACUNIT,  P_RandomRange(-distance, distance)*FRACUNIT, P_RandomRange(-distance, distance)*FRACUNIT, MT_SMALLBUBBLE)
		P_InstaThrust(fx, rush.angle, -10*FRACUNIT)
		fx.momz = P_RandomRange(-10, 10)*FRACUNIT
		P_InstaThrust(rush, rush.angle, 36*FRACUNIT)
	else
		P_InstaThrust(rush, rush.angle, 0)
	end
	if player.cmd.buttons & BT_JUMP
		rush.momz = 10*FRACUNIT
	elseif player.cmd.buttons & BT_SPIN
		rush.momz = -10*FRACUNIT
	else
		rush.momz = 0
	end
	player.powers[pw_underwater] = 999*TICRATE
	P_MoveOrigin(mo, rush.x, rush.y, rush.z)
	rush.angle = mo.angle
	mo.state = S_PLAY_PAIN
	if rush.rushtimer < 5
		rush.rushtimer = 0
		player.rushflytimer = $ - 1
	end
	if player.rushflytimer == 0
	or (mo.eflags & MFE_SPRUNG)
	or player.exiting == 1
	or (player.playerstate & PST_DEAD)
	or not (rush.eflags & MFE_UNDERWATER)
	or player.cmd.buttons & BT_CUSTOM1
		player.weapondelay = TICRATE
		player.rushout = false
		mo.flags = $&~(MF_NOGRAVITY|MF_FLOAT)
		P_DoJump(player, true)
		rush.target = nil
		P_KillMobj(rush, rush, rush)
	end
end, MT_RUSHMARINE)
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.rushout == nil
			player.rushout = false
		end
		if player.rushflytimer == nil
			player.rushflytimer = 500
		end
		if P_IsObjectOnGround(player.mo)
		and player.rushflytimer ~= 500
			player.rushflytimer = $ + 1
		end
		if player.custom1out == nil
			player.custom1out = false
		end
		if not (player.cmd.buttons & BT_CUSTOM1)
		and not (player.cmd.buttons & BT_CUSTOM2)
			player.custom1out = false
		end
		if player.rushout == false
		and player.playerstate == PST_LIVE
		and player.cmd.buttons & BT_CUSTOM1
		and not player.weapondelay
		and player.custom1out == false
			player.custom1out = true
			if P_IsObjectOnGround(player.mo)
			and not (player.mo.eflags & MFE_UNDERWATER)
				player.rushout = true
				player.weapondelay = TICRATE
				local rush = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_RUSHCOIL)
				P_TryMove(rush, player.mo.x+P_ReturnThrustX(nil, player.drawangle, player.mo.radius*10),
				player.mo.y+P_ReturnThrustY(nil, player.drawangle, player.mo.radius*10), true)
				rush.target = player.mo
				S_StartSound(player.mo, sfx_s1c9, player)
				player.mo.state = S_PLAY_SKID
			elseif not P_IsObjectOnGround(player.mo)
			and not (player.mo.eflags & MFE_UNDERWATER)
				player.rushout = true
				player.weapondelay = TICRATE
				local rush = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_RUSHJET)
				P_TryMove(rush, player.mo.x+P_ReturnThrustX(nil, player.drawangle, player.mo.radius*10),
				player.mo.y+P_ReturnThrustY(nil, player.drawangle, player.mo.radius*10), true)
				S_StartSound(player.mo, sfx_s1c9, player)
				player.mo.state = S_PLAY_SKID
			elseif player.mo.eflags & MFE_UNDERWATER
				player.rushout = true
				player.weapondelay = TICRATE
				local rush = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_RUSHMARINE)
				P_TryMove(rush, player.mo.x+P_ReturnThrustX(nil, player.drawangle, player.mo.radius*10),
				player.mo.y+P_ReturnThrustY(nil, player.drawangle, player.mo.radius*10), true)
				S_StartSound(player.mo, sfx_s1c9, player)
				player.mo.state = S_PLAY_SKID
			end
		end
		if player.rushout == false
		and player.playerstate == PST_LIVE
		and player.cmd.buttons & BT_CUSTOM2
		and not player.weapondelay
		and player.custom1out == false
			player.custom1out = true
			player.rushout = true
			player.weapondelay = TICRATE
			local rush = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_TREBLE)
			P_TryMove(rush, player.mo.x+P_ReturnThrustX(nil, player.drawangle, player.mo.radius*10),
			player.mo.y+P_ReturnThrustY(nil, player.drawangle, player.mo.radius*10), true)
			rush.target = player.mo
			S_StartSound(player.mo, sfx_s1c9, player)
			player.mo.state = S_PLAY_SKID
		end
	end
end)

addHook("PlayerSpawn", function(player)
	player.rushout = false
end)

local pos = hudinfo[HUD_LIVES].y +5
local function rush_hud(v, player)
	if player.mo.valid
		v.drawFill(150,pos - 1, 105, 12, 31)
		v.drawFill(151,pos, player.rushflytimer/5, 10, skincolors[player.skincolor].ramp[5]) 
	end
end

hud.add(rush_hud, "game")